| The Red Matrix

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Pages
Functions
item.php File Reference

## Functions
| item_post (&$a)
| item_content (&$a)
| fix_attached_photo_permissions ($uid, $xchan_hash, $body, $str_contact_allow, $str_group_allow, $str_contact_deny, $str_group_deny)
| fix_attached_file_permissions ($channel, $observer_hash, $body, $str_contact_allow, $str_group_allow, $str_contact_deny, $str_group_deny)
| item_check_service_class ($channel_id, $iswebpage)

## Function Documentation

fix_attached_file_permissions | ( |  | $channel,
|  |  | $observer_hash,
|  |  | $body,
|  |  | $str_contact_allow,
|  |  | $str_group_allow,
|  |  | $str_contact_deny,
|  |  | $str_group_deny
| ) |  |

Referenced by item_post().

fix_attached_photo_permissions | ( |  | $uid,
|  |  | $xchan_hash,
|  |  | $body,
|  |  | $str_contact_allow,
|  |  | $str_group_allow,
|  |  | $str_contact_deny,
|  |  | $str_group_deny
| ) |  |

Referenced by item_post().

item_check_service_class | ( |  | $channel_id,
|  |  | $iswebpage
| ) |  |

Referenced by item_post().

item_content | ( | & | $a | ) |

item_post | ( | & | $a | ) |

This is the POST destination for most all locally posted text stuff. This function handles status, wall-to-wall status, local comments, and remote coments that are posted on this site (as opposed to being delivered in a feed). Also processed here are posts and comments coming through the statusnet/twitter API. All of these become an "item" which is our basic unit of information. Posts that originate externally or do not fall into the above posting categories go through item_store() instead of this function.

Is this a reply to something?

fix naked links by passing through a callback to see if this is a red site (already known to us) which will get a zrl, otherwise link with url, add bookmark tag to both. First protect any url inside certain bbcode tags so we don't double link it.

When a photo was uploaded into the message using the (profile wall) ajax uploader, The permissions are initially set to disallow anybody but the owner from seeing it. This is because the permissions may not yet have been set for the post. If it's private, the photo permissions should be set appropriately. But we didn't know the final permissions on the post until now. So now we'll look for links of uploaded photos and attachments that are in the post and set them to the same permissions as the post itself.

If the post was end-to-end encrypted we can't find images and attachments in the body, use our media_str input instead which only contains these elements - but only do this when encrypted content exists because the photo/attachment may have been removed from the post and we should keep it private. If it's encrypted we have no way of knowing so we'll set the permissions regardless and realise that the media may not be referenced in the post.

What is preventing us from being able to upload photos into comments is dealing with the photo and attachment permissions, since we don't always know who was in the distribution for the top level post.

We might be able to provide this functionality with a lot of fiddling:

- if the top level post is public (make the photo public)
- if the top level post was written by us or a wall post that belongs to us (match the top level post)
- if the top level post has privacy mentions, add those to the permissions.
- otherwise disallow the photo or make the photo public. This is the part that gets messy.

Fold multi-line [code] sequences

Referenced by api_statuses_mediap(), api_statuses_repeat(), api_statuses_update(), oexchange_content(), and red_item_new().